//#define UNICODE
#ifdef UNICODE
  #define _UNICODE
#endif
#include <windows.h>
#include <tchar.h>

BOOL WINAPI CtrlHandler(DWORD fdwCtrlType) {  
  return(TRUE);
} 

BOOL WINAPI SpawnAndControlConsoleChild(LPTSTR ModuleName) {
  static STARTUPINFO si = {sizeof(si)};
  PROCESS_INFORMATION pi;
  BOOL result = FALSE;

  #define MBTitle _T("GuiFather")

  FreeConsole();
  if(AllocConsole()) {
    if(SetConsoleCtrlHandler(CtrlHandler, TRUE)) {
      if(CreateProcess(NULL, ModuleName, NULL, NULL, FALSE,
          CREATE_NEW_PROCESS_GROUP | CREATE_DEFAULT_ERROR_MODE,
          NULL, NULL, &si, &pi)) {
        MessageBox(NULL, _T("Press OK to generate ctrl event."), MBTitle, MB_OK);
        HFILE hvw;
        if( (hvw = _lopen("\\\\.\\VWIN32", OF_READ)) != HFILE_ERROR) {
          #define VWIN32_DIOC_SIMCTRLC 5 
          DeviceIoControl((HANDLE)hvw, VWIN32_DIOC_SIMCTRLC,
            &pi.dwProcessId,sizeof(pi.dwProcessId),
            NULL,0, NULL,NULL);
          _lclose(hvw);
        } 
        GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT, pi.dwProcessId);
        FreeConsole(); //cosmetics: remove console window immediately
        if(WaitForSingleObject(pi.hProcess, 5000) == WAIT_OBJECT_0) {
          MessageBox(NULL, _T("Console children don't exist."), MBTitle, MB_OK);
          result = TRUE;
        }
        else {
          MessageBox(NULL, _T("Console children don't exist?"), MBTitle, MB_OK);
        }
        CloseHandle(pi.hProcess);
        CloseHandle(pi.hThread);    
      }
      else {
        MessageBox(NULL, _T("Can't spawn child!"), MBTitle, MB_OK);
      }
      SetConsoleCtrlHandler(CtrlHandler, FALSE);
    }
    else {
      MessageBox(NULL, _T("Can't set ctrl handler!"), MBTitle, MB_OK);
    }
    FreeConsole();
  }
  else {
    MessageBox(NULL, _T("Can't allocate console!"), MBTitle, MB_OK);
  }
  return(result);
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
  //....
  SpawnAndControlConsoleChild(_T("NeverendingConsole.exe"));
  //....
  return(0);
}